// [ONI'2016] Selecao: Problema D - Fragmentos de ADN
// Ficheiro com um avaliador exemplo para poder testar na sua maquina
// (note que o avaliador oficial sera diferente!)

#include "adn.h"

#include <cstdio>
#include <cstdlib>

#define MAX 3005

int M, N, P, posResposta, numAnalises;
int molecula[MAX], res[MAX];

int analisar(int i, int j) {
  int a, b, contar;
  numAnalises++;
  if (numAnalises > P) {
    puts("ERRO: mais chamadas a analisar do que o permitido");
    exit(-1);
  }
  if (i<1 || i>N || j<1 || j>N || i>j) {
    printf("ERRO: chamada a analisar(%d,%d) com argumentos errados\n", i, j);
    exit(-1);
  }
  contar = 1;
  for (a=i+1; a<=j; a++) {
    for (b=i; b<a; b++)
      if (molecula[a] == molecula[b]) break;
    if (b==a) contar++;
  }
  return contar;
}

void resposta(int i) {
  if (posResposta>N) {
    puts("ERRO: resposta(i) chamada mais do que N vezes");
    exit(-1);
  }
  if (i<1 || i>N) {
    printf("ERRO: chamada a resposta(%d) com argumentos errados\n", i);
    exit(-1);
  } 

  res[posResposta++] = i;
}

void verificarResposta() {
  int i, j;
  if (posResposta<N) {
    puts("ERRO: resposta(i) nao foi chamada N vezes");
    exit(-1);
  }

  printf("Resposta:");
  for (i=1; i<=N; i++) printf(" %d", res[i]);
  putchar('\n');
  
  for (i=1; i<=N; i++)
    for (j=1; j<=N; j++)
      if ( (molecula[i] == molecula[j] && res[i] != res[j]) ||
	   (molecula[i] != molecula[j] && res[i] == res[j]) ) {
	puts("ERRO: codificacao errada!");
	exit(-1);
      }

  
  printf("Correcto! [apos %d chamada(s) a analisar()]\n", numAnalises);
}

int main() {
  int i, j;
  scanf("%d %d", &M, &P);
  for (i=0; i<M; i++) {
    scanf("%d", &N);    
    for (j=1; j<=N; j++) scanf("%d", &molecula[j]);

    printf("Molecula:");
    for (j=1; j<=N; j++) printf(" %d", molecula[j]);
    putchar('\n');

    numAnalises = 0;
    posResposta = 1;
    resolver(N);
    verificarResposta();

    puts("-------------------------------------------------------");
  }
  return 0;
}
