// [ONI'2016] Selecao: Problema D - Fragmentos de ADN
// Ficheiro com um avaliador exemplo para poder testar na sua maquina
// (note que o avaliador oficial sera diferente!)

import java.util.Scanner;
import java.lang.System;

class avaliador {
    private static int M, N, P, posResposta, numAnalises;
    private static int molecula[], res[];

    public static int analisar(int i, int j) {
	int a, b;
	numAnalises++;
	if (numAnalises > P) {
	    System.out.println("ERRO: mais chamadas a analisar do que o permitido");
	    System.exit(-1);
	}
	if (i<1 || i>N || j<1 || j>N || i>j) {
	    System.out.printf("ERRO: chamada a analisar(%d,%d) com argumentos errados\n", i, j);
	    System.exit(-1);
	}
	int contar = 1;
	for (a=i+1; a<=j; a++) {
	    for (b=i; b<a; b++)
		if (molecula[a] == molecula[b]) break;
	    if (b==a) contar++;
	}
	return contar;
    }

    public static void resposta(int i) {
	if (posResposta>N) {
	    System.out.println("ERRO: resposta(i) chamada mais do que N vezes");
	    System.exit(-1);
	}
	if (i<1 || i>N) {
	    System.out.printf("ERRO: chamada a resposta(%d) com argumentos errados\n", i);
	    System.exit(-1);
	} 

	res[posResposta++] = i;
    }

    private static void verificarResposta() {
	if (posResposta<N) {
	    System.out.println("ERRO: resposta(i) nao foi chamada N vezes");
	    System.exit(-1);
	}

	System.out.print("Resposta:");
	for (int i=1; i<=N; i++) System.out.printf(" %d", res[i]);
	System.out.println();
  
	for (int i=1; i<=N; i++)
	    for (int j=1; j<=N; j++)
		if ( (molecula[i] == molecula[j] && res[i] != res[j]) ||
		     (molecula[i] != molecula[j] && res[i] == res[j]) ) {
		    System.out.println("ERRO: codificacao errada!");
		    System.exit(-1);
		}

  
	System.out.printf("Correcto! [apos %d chamada(s) a analisar()]\n", numAnalises);
    }

    public static void main(String args[]) {
	Scanner in = new Scanner(System.in);
	M = in.nextInt();
	P = in.nextInt();
	
	for (int i=0; i<M; i++) {
	    N = in.nextInt();
	    molecula = new int[N+1];
	    res      = new int[N+1];
	    for (int j=1; j<=N; j++) molecula[j] = in.nextInt();

	    System.out.print("Molecula:");
	    for (int j=1; j<=N; j++) System.out.printf(" %d", molecula[j]);
	    System.out.println();

	    numAnalises = 0;
	    posResposta = 1;
	    resolver.resolver(N);
	    verificarResposta();

	    System.out.println("-------------------------------------------------------");
	}
    }
}
